; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    hex2dw_ex PROTO :DWORD
    extend    PROTO :DWORD

    .data
      align 16
      ac_table \
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0
        db 0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

      tbl1 \
        db 00h,10h,20h,30h,40h,50h,60h,70h,80h,90h,0,0,0,0,0,0      ; 63
        db 00h,0A0h,0B0h,0C0h,0D0h,0E0h,0F0h,0,0,0,0,0,0,0,0,0      ; 79
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                          ; 95
        db 00h,0A0h,0B0h,0C0h,0D0h,0E0h,0F0h

      tbl2 \
        db 00h,01h,02h,03h,04h,05h,06h,07h,08h,09h,0,0,0,0,0,0      ; 63
        db 00h,0Ah,0Bh,0Ch,0Dh,0Eh,0Fh,0,0,0,0,0,0,0,0,0            ; 79
        db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0                          ; 95
        db 00h,0Ah,0Bh,0Ch,0Dh,0Eh,0Fh

      ; sub 48 from both tables

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    fn hex2dw_ex,"12345678"

    print hex$(eax),13,10

    ret

main endp

; 

align 16

hex2dw_ex proc phex:DWORD

    LOCAL var   :DWORD
    LOCAL buffer[32]:BYTE

    push ebx
    push esi
    push edi

    mov var, 0                  ; zero fill var

    lea edi, buffer
    mov eax, "0000"
    mov DWORD PTR [edi],   eax
    mov DWORD PTR [edi+4], eax

    mov esi, phex
    lea edx, [edi+8]
    mov ecx, -1
  @@:
    add ecx, 1
    mov al, [esi+ecx]
    mov [edx+ecx], al
    test al, al
    jnz @B

    add edi, ecx
    mov edx, edi
    lea edi, var

    movzx eax, BYTE PTR [edx]
    cmp BYTE PTR [ac_table+eax], 0
    je hout
    mov cl, [eax+tbl1-48]
    movzx ebx, BYTE PTR [edx+1]
    cmp BYTE PTR [ac_table+ebx], 0
    je hout
    add cl, [ebx+tbl2-48]
    mov [edi+3], cl

    movzx eax, BYTE PTR [edx+2]
    cmp BYTE PTR [ac_table+eax], 0
    je hout
    mov cl, [eax+tbl1-48]
    movzx ebx, BYTE PTR [edx+3]
    cmp BYTE PTR [ac_table+ebx], 0
    je hout
    add cl, [ebx+tbl2-48]
    mov [edi+2], cl

    movzx eax, BYTE PTR [edx+4]
    cmp BYTE PTR [ac_table+eax], 0
    je hout
    mov cl, [eax+tbl1-48]
    movzx ebx, BYTE PTR [edx+5]
    cmp BYTE PTR [ac_table+ebx], 0
    je hout
    add cl, [ebx+tbl2-48]
    mov [edi+1], cl

    movzx eax, BYTE PTR [edx+6]
    cmp BYTE PTR [ac_table+eax], 0
    je hout
    mov cl, [eax+tbl1-48]
    movzx ebx, BYTE PTR [edx+7]
    cmp BYTE PTR [ac_table+ebx], 0
    je hout
    add cl, [ebx+tbl2-48]
    mov [edi], cl

  hout:
    mov eax, var

    pop edi
    pop esi
    pop ebx

    ret

hex2dw_ex endp

; 

end start
